package se.nekotronic.zombieattack;

import android.os.Bundle;
import android.app.Activity;
import android.text.format.Time;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Random;

public class ZombieAttackActivity extends Activity implements OnClickListener {
	public final static String DEFAULT_SERVER = "basen.oru.se";
	public final static int DEFAULT_PORT = 2002;

	private EditText latitude_field;
	private EditText longitude_field;
    private Button attack_button;
    private EditText output_field;
    
    double latitude, longitude;
    
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_zombie_attack);
		latitude_field = (EditText) findViewById(R.id.latitude_field);
		longitude_field = (EditText) findViewById(R.id.longitude_field);
		output_field = (EditText) findViewById(R.id.output_field);
		attack_button = (Button) findViewById(R.id.attack_button);
        attack_button.setOnClickListener(this);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.zombie_attack, menu);
		return true;
	}

	@Override
	public void onClick(View v) {
		if (v == attack_button)
			attack();
		else
			print("This can't be happening!");
	}

	private void attack() {
		try {
			latitude = Double.parseDouble(latitude_field.getText().toString());
			longitude = Double.parseDouble(longitude_field.getText().toString());
			if (latitude < -180 || latitude > 180 || longitude < -180 || longitude > 180) {
				print("That's not a valid position!");
			}
			else {
				for (int i = 0; i < 3; ++i) {
					ZombieLoginThread z = new ZombieLoginThread(this);
					z.start();
				}
			}
		}
		catch(NumberFormatException e) {
			print("That's not a valid number!");
		}
	}
	
    private static final int OUTPUT_LINES = 8;
    private String printlines[] = new String[OUTPUT_LINES];
    int num_printlines = 0;

    public void print(String text) {
    	Time now = new Time();
    	now.setToNow();
    	String timeString = now.format("%H:%M:%S");
    	String line = timeString + ": " + text;

    	if (num_printlines == printlines.length) {
    		for (int i = 0; i < num_printlines - 1; ++i)
    			printlines[i] = printlines[i + 1];
    		--num_printlines;
    	}
    	printlines[num_printlines++] = line;
    	String alltext = "";
    	for (int i = 0; i < num_printlines; ++i)
    		alltext = alltext + printlines[i] + "\n";
    	final String final_alltext = alltext;

    	// This method might be called from another thread
    	runOnUiThread(new Runnable() {
    		@Override
    		public void run() {
    			// TODO Auto-generated method stub
    			output_field.setText(final_alltext);
    			output_field.invalidate();
    			output_field.postInvalidate();
    		} });

    } // print

	public double get_latitude() {
		return latitude;
	}

	public double get_longitude() {
		return longitude;
	}

} // ZombieAttackActivity

class ZombieLoginThread extends Thread {
	ZombieAttackActivity parent_activity;
	static int random_number = -1;
	static int number_of_zombies = 0;
	int zombie_number;
	String zombie_name;
	
	public ZombieLoginThread(ZombieAttackActivity parent_activity) {
		this.parent_activity = parent_activity;
		synchronized ("whatever") {
			if (random_number == -1) {
				Random prng= new Random();
				random_number = Math.abs(prng.nextInt());
			}
			zombie_number = ++number_of_zombies;
		}
		zombie_name = "sim-zombie-" + random_number + "-" + zombie_number;
	}
	
	void sleepseconds(int seconds) {
		try {
			Thread.sleep(seconds * 1000);
		} catch (InterruptedException e) {
			parent_activity.print("Sleep failed.");
		}
	}
	
	void sleepsecond() {
		sleepseconds(1);
	}

	public void run() {
		parent_activity.print("Staring thread " + zombie_name + "...");

		Socket socket = null;
		BufferedReader from_server;
		PrintWriter to_server;
		
		try {
			InetAddress addr = InetAddress.getByName(ZombieAttackActivity.DEFAULT_SERVER);
			parent_activity.print("Kopplar upp mot servern...");
			socket = new Socket(addr, ZombieAttackActivity.DEFAULT_PORT);
			from_server = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			to_server = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);			
			// true: PrintWriter is line buffered
			
			to_server.println("1 REGISTER " + zombie_name + " " + zombie_name);
			sleepsecond();
			to_server.println("2 LOGIN " + zombie_name + " " + zombie_name);
			sleepsecond();
			to_server.println("3 TURN ZOMBIE");
			sleepsecond();
			to_server.println("4 I-AM-AT " + parent_activity.get_latitude() + " " + parent_activity.get_longitude());
			sleepseconds(3);
			to_server.println("5 LOGOUT");
			sleepsecond();
		}
		catch (UnknownHostException e) {
			parent_activity.print("Connection failed with UnknownHostException: " + e);
		}
		catch (IOException e) {
			parent_activity.print("Connection failed with IOException: " + e);
			if (socket != null) {
				try {
					socket.close();
				}
				catch (IOException e1) {
					// Error when closing the socket. Not much we can or should do here, so do nothing.
				}
			}
		}
		catch (Exception e) {
			parent_activity.print("Some other problem in the thread: e = " + e);
		}

		parent_activity.print("Finished thread " + zombie_name + ".");
	} // run
} // ZombieLoginThread
